org.mozilla.javascript.tools.shell

## Class ShellConsole

- java.lang.Object
- - org.mozilla.javascript.tools.shell.ShellConsole

-     public abstract class ShellConsole
      extends java.lang.Object

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `ShellConsole()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract void` | `flush()` Flushes the console's output
    `static ShellConsole` | `getConsole(java.io.InputStream in, java.io.PrintStream ps, java.nio.charset.Charset cs)` Returns a new `ShellConsole` which uses the supplied `InputStream` and `PrintStream` for its input/output
    `static ShellConsole` | `getConsole(Scriptable scope, java.nio.charset.Charset cs)` Provides a specialized `ShellConsole` to handle line editing, history and completion.
    `abstract java.io.InputStream` | `getIn()` Returns the underlying `InputStream`
    `abstract void` | `print(java.lang.String s)` Prints a single string to the console
    `abstract void` | `println()` Prints the newline character-sequence to the console
    `abstract void` | `println(java.lang.String s)` Prints a string and the newline character-sequence to the console
    `abstract java.lang.String` | `readLine()` Reads a single line from the console
    `abstract java.lang.String` | `readLine(java.lang.String prompt)` Reads a single line from the console and sets the console's prompt to `prompt`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ShellConsole

          protected ShellConsole()

  - ### Method Detail

    - #### getIn

          public abstract java.io.InputStream getIn()

      Returns the underlying `InputStream`

    - #### readLine

          public abstract java.lang.String readLine()
                                             throws java.io.IOException

      Reads a single line from the console
      Throws:
        `java.io.IOException`

    - #### readLine

          public abstract java.lang.String readLine(java.lang.String prompt)
                                             throws java.io.IOException

      Reads a single line from the console and sets the console's prompt to `prompt`
      Throws:
        `java.io.IOException`

    - #### flush

          public abstract void flush()
                              throws java.io.IOException

      Flushes the console's output
      Throws:
        `java.io.IOException`

    - #### print

          public abstract void print(java.lang.String s)
                              throws java.io.IOException

      Prints a single string to the console
      Throws:
        `java.io.IOException`

    - #### println

          public abstract void println()
                                throws java.io.IOException

      Prints the newline character-sequence to the console
      Throws:
        `java.io.IOException`

    - #### println

          public abstract void println(java.lang.String s)
                                throws java.io.IOException

      Prints a string and the newline character-sequence to the console
      Throws:
        `java.io.IOException`

    - #### getConsole

          public static ShellConsole getConsole(java.io.InputStream in,
                                                java.io.PrintStream ps,
                                                java.nio.charset.Charset cs)

      Returns a new `ShellConsole` which uses the supplied `InputStream` and `PrintStream` for its input/output

    - #### getConsole

          public static ShellConsole getConsole(Scriptable scope,
                                                java.nio.charset.Charset cs)

      Provides a specialized `ShellConsole` to handle line editing, history and completion. Relies on the JLine library (see ).